import React, { PropTypes } from 'react'
import styled, { css } from 'styled-components'

const parseProps = ({ backgroundColor, style, ...props }) => {
  const newStyles = {}

  newStyles.backgroundColor = backgroundColor

  return { style: { ...newStyles, ...style }, ...props }
}

const withBackgroundColor = (Comp) => {
  const BackgroundColorComp = (props) =>
    React.createElement(Comp, parseProps(props))

  BackgroundColorComp.propTypes = {
    ...Comp.propTypes,
    backgroundColor: PropTypes.string
  }

  BackgroundColorComp.displayName = Comp.displayName

  return BackgroundColorComp
}

export {
  withBackgroundColor
}
